<?php
use \Homegear\Homegear as Homegear;
$componentUpdates = 'Updates';

$hg = new Homegear();
$id = (isset($_REQUEST['id']) ? $_REQUEST['id'] : null);
$type = (isset($_REQUEST['type']) ? $_REQUEST['type'] : null);

header('Content-Type: application/json');
if ($type === null || $id === null) {
    echo json_encode(['status' => 'error', 'message' => 'id or type missing']);
    exit(0);
}
try {
    //$result = $hg->managementGetCommandStatus(intval($id));
    $result = $hg->managementAptRunning();
} catch(\Homegear\HomegearException $e) {
    $code = $e->getCode();
    if ($code == -2) {
        // ID unknown
        echo json_encode(['status' => 'error', 'message' => 'id unknown']);
        exit(0);
    } elseif ($code == -32601) {
        // homegear-management not running
        echo json_encode(['status' => 'true', 'message' => 'management daemon not running']);
        exit(0);
    }
}
//if (isset($result) && array_key_exists('finished',$result)) {
if (isset($result) && $result === true) {
    // update still running
    echo json_encode(['status' => 'true']);
    exit(0);
} else {
    // update finished
    $result = exec('apt list --upgradable 2>/dev/null | grep -c homegear-smarthaui');
    if (isset($result) && intval($result) == 0) {
        $hg->deleteData($componentUpdates,'UpdateAvailable_UI');
    }
    $result = exec('apt list --upgradable 2>/dev/null | grep -c homegear-smartha-devicedefinitions');
    if (isset($result) && intval($result) == 0) {
        $hg->deleteData($componentUpdates,'UpdateAvailable_DeviceDefinitions');
    }
    if (!$hg->managementHomegearUpdateAvailable()) {
        $hg->deleteData($componentUpdates,'UpdateAvailable_Homegear');
    }
    if (!$hg->managementSystemUpdateAvailable()) {
        $hg->deleteData($componentUpdates,'UpdateAvailable_System');
    }
    setOled();
    echo json_encode(['status' => 'false']);
    exit(0);
}
echo json_encode(['status' => 'error', 'message' => 'unknown error']);

function setOled($msg = null)
{
    if (file_exists('/usr/share/smartha-oled/smartha_display.py')) {
        if (file_exists('/data/disable_oled')) {
            rename('/data/disable_oled', '/data/disable_oled_tmp');
        }
        if (file_exists('/data/disable_oled_tmp')) {
            rename('/data/disable_oled_tmp', '/data/disable_oled');
        }
        if ($msg == null) {
            exec('python /usr/share/smartha-oled/smartha_display.py');
        } else {
            exec('python /usr/share/smartha-oled/smartha_display.py -t "'.$msg.'"');
        }
    }
}